/* 
 THIS SAS PROGRAM READS MARCH 1990 CURRENT POPULATION SURVEY
 AND PULLS MICRO DATA FOR FEMALE AGE 16 TO 70.
*/ 
LIBNAME SCR '/otel1e/cpstemp'; 
OPTIONS LS=80; 
/* OPTIONS OBS=4000; */

FILENAME CPSMAR90 '/otel1e/cpstemp/cps90.dat';
 
DATA SCR.CPS90fm; 
 
TITLE1 'MARCH 19900 CPS DATA FOR ALL WOMEN 16-70 YEARS OF AGE';
TITLE2 'CPS DATA COPIED FROM TAPE CPS90 (KEVIN MURPHY)'; 

INFILE CPSMAR90 LRECL=600; 
 
LENGTH 
/* For the household record: */ 
hhpos        3
hhtype       3
numpers      3
numfam       3
h_type       3
region       3
division     3 
state        3
stofres      3
mprank       3
msasize      3 
msmsa        3 
hhstatus     3
/* For the family record: */ 
famseq       8
ftype        3 
fkind        3
fnumper      3
chld6        3
chldnm18     3
fundr6       3
fundr18      3
fprctcut     4
fincws       8
fincse       8
fincfr       8
fincuc       8
fincwc       8
fincss       8
fincsp       7
fincpa       7
fincvet      8
fincsur      8
fincdis      8
fincret      8
fincint      8
fincdiv      8
fincrent     8
finced       8
fincchld     8
fincalm      8
fincfin      8
fincoi       8
finctot      8 
fincearn     8 
fincoth      8 
fam18t64     3 
fam65ovr     3 
chld18       3
chld15       3
chld12       3 
chld3        3 
chld1        3 
chldygst     3
chldolst     3
fam5t17      3 
faminlf      3 
famearnr     3 
/* For the person record: */ 
exprrp       3 
age          3
marstat      3
sex          3
highgrad     3
gradecom     3 
race         3
popstat      3
famtype      3
famrel       3
pfrel        3
relhead      3
parent       3
weight       8
actlw        3 
hrwrklw      3
uhwov35      3 
lookpt       3
lwrk2wks     3 
industry     4
occup        4
class        3 
lstwrpay     3 
whylstj      3
wantrj       3 
lkintend     3
hrswork      3
paidhour     3
earnhour     5
earnweek     5
union        3
hscolat      3
hsorcol      3
lfsr         3
fullpart     3
explf        3
lookwrly     3
wkslook      3
wkwrkly      3
lkweek       3
numempl      3 
hrwkly       3
wkpartim     3
class_ly     3 
ind_ly       4
occ_ly       4
migsame      3
reg_ly       3
stately      3
ruacplds     3
earnsrc      3
incwgsal     7
incse        7
incfarm      7
incuc        6
incwc        6
incss        6
incsups      5
incpuas      6
incvet       6
incsur       7
incdis       7
incret       7
incint       6
incdiv       6
inced        6
incchld      6
incalm       6
incfin       6
oi_src       3
incosrc      6
inctot       8
incearn      8
incoth       8;
     
 *START OF LOOP;         

INPUT TYPE 7-8 @; 
NEXTHH: ;

IF TYPE GT 40 AND TYPE LT 80 THEN DO;
    GO TO NEXTPER;
    END;
 
ELSE IF TYPE GT 0 AND TYPE LT 40 THEN DO;
    GO TO NEXTFAM;
    END;
  
 ELSE DO;
    *READ HOUSEHOLD RECORD;
 
    INPUT HHTYPE 20 NUMPERS 21-22 NUMFAM 23-24 H_TYPE 25 REGION 39 DIVISION 40
          STATE 40-41 STOFRES 42-43 MPRANK 50-52 MSASIZE 55 MSMSA 57 
          HHSTATUS 278;
  
    DO IFAM=1 TO NUMFAM;
      INPUT TYPE 7-8 @;
      NEXTFAM:;
      IF TYPE = 0 THEN DO;
           GO TO NEXTHH;
           END;
      ELSE IF TYPE GT 40 AND TYPE LT 80 THEN DO; 
           GO TO NEXTPER; 
           END; 
    *READ FAMILY RECORD;
 
      ELSE INPUT FAMSEQ 2-8 FTYPE 9 FKIND 10 FNUMPER 11-12 CHLD6 25
           CHLDNM18 27 FUNDR6 28 FUNDR18 29 FPRCTCUT 30-31 FINCWS 48-54
           FINCSE 56-62 FINCFR 64-70 FINCUC 72-78 FINCWC 80-86
           FINCSS 88-94 FINCSP 96-101 FINCPA 103-108 FINCVET 110-116
           FINCSUR 118-124 FINCDIS 126-132 FINCRET 134-140 FINCINT 142-148
           FINCDIV 150-156 FINCRENT 158-164 FINCED 166-172
           FINCCHLD 174-180 FINCALM 182-188 FINCFIN 190-196 FINCOI 198-204
           FINCTOT 205-212 FINCEARN 213-220 FINCOTH 221-228;

      DO IP = 1 TO FNUMPER;   /* LOOP OVER PERSONS IN FAMILY */ 
 
         NEXTPER:;   /*KLUGE: IN CASE OF BAD REC STRUCTURE */ 
 
         INPUT TYPE 7-8 AGE 15-16 SEX 20 @;

         IF TYPE =0 THEN DO; 
           GO TO NEXTHH ; 
           END; 
 
         ELSE IF TYPE GT 0 AND TYPE LT 40 THEN DO; 
           IFAM=IFAM+1; 
           GO TO NEXTFAM; 
           END; 
 
         ELSE IF 15<AGE<71 and sex>1 THEN DO; 
           INPUT EXPRRP 13-14 MARSTAT 17 HIGHGRAD 22-23 GRADECOM 24 RACE 25
           POPSTAT 26 FAMTYPE 31 FAMREL 32 PFREL 33 RELHEAD 34 PARENT 39
           WEIGHT 50-57 ACTLW 74 HRWRKLW 76-77 UHWOV35 79 LOOKPT 99
           LWRK2WKS 102 INDUSTRY 103-105 OCCUP 106-108 CLASS 109 LSTWRPAY 112 
           WHYLSTJ 113 WANTRJ 114 LKINTEND 126 HRSWORK 128-129 PAIDHOUR 130 
           EARNHOUR 131-134 EARNWEEK 135-138 UNION 139 HSCOLAT 142 HSORCOL 143
           LFSR 145 FULLPART 149 EXPLF 150 LOOKWRLY 167 WKSLOOK 168-169 
           REASNWLY 170 WKWRKLY 171-172 LKWEEK 176-177 NUMEMPL 180 
           HRWKLY 181-182 WKPARTIM 185-186 CLASS_LY 189 IND_LY 190-192
           OCC_LY 193-195 MIGSAME 214 REG_LY 215 STATELY 216-217 RUACPLDS 224
           EARNSRC 234 INCWGSAL 243-248 INCSE 256-261 INCFARM 269-274 
           INCUC 278-282 INCWC 285-289 INCSS 291-295 INCSUPS 297-300 
           INCPUAS 305-309 INCVET 317-321 INCSUR 337-342 INCDIS 360-365 
           INCRET 379-384 INCINT 386-390 INCDIV 393-397 INCED 408-412 
           INCCHLD 415-419 INCALM 421-425 INCFIN 427-431 OI_SRC 432-433 
           INCOSRC 435-439 INCTOT 440-447 INCEARN 448-455 INCOTH 457-464;
           END; 
           ELSE DO; 
           INPUT; 
           GO TO NEXTPER; 
           END; 
 
           WEIGHT=WEIGHT/100;
 
      DROP TYPE IP IFAM; 
 
         OUTPUT; 
 
      END;  /* END OF PERSON LOOP*/ 
    END;  /* END OF FAMILY LOOP*/ 
END;  /* END OF HOUSEHOLD LOOP */ 
 
PROC CONTENTS DATA = SCR.CPS90fm; 
PROC FREQ DATA = SCR.CPS90fm; TABLES RACE; 
PROC FREQ DATA = SCR.CPS90fm; TABLES AGE;
PROC FREQ DATA = SCR.CPS90fm; TABLES WKWRKLY;
PROC MEANS DATA = SCR.CPS90fm; 
/* 
