/* 
 THIS SAS PROGRAM READS MARCH 1990 CURRENT POPULATION SURVEY
 AND PULLS MICRO DATA FOR FEMALE AGE 16 TO 70.
*/ 
LIBNAME SCR '/otel1e/cpstemp'; 
OPTIONS LS=80; 
/* OPTIONS OBS=4000; */

FILENAME CPSMAR90 '/otel1e/cpstemp/cps90.dat';
 
DATA SCR.CPS90fmb; 
 
TITLE1 'MARCH 1990 CPS DATA FOR ALL WOMEN 16-70 YEARS OF AGE';
TITLE2 'CPS DATA COPIED FROM TAPE CPS90 (KEVIN MURPHY)'; 

INFILE CPSMAR90 LRECL=600 END=LASTREC; 
 
LENGTH 
/* For the household record: */ 
numfam       3
/* For the family record: */ 
famseq       8
fnumper      3
fam18t64     3 
fam65ovr     3 
chld18       3
chld15       3
chld12       3 
chld3        3 
chld1        3 
chldygst     3
chldolst     3
fam5t17      3 
faminlf      3 
famearnr     3 
/* For the person record: */ 
exprrp       3 
age          3
marstat      3
famtype      3
famrel       3
pfrel        3
relhead      3
lfsr         3
explf        3
incwgsal     7
incearn      8;
     
 *START OF LOOP;         

INPUT TYPE 7-8 @; 
NEXTHH: ;

IF TYPE GT 40 AND TYPE LT 80 THEN DO;
    GO TO NEXTPER;
    END;
 
ELSE IF TYPE GT 0 AND TYPE LT 40 THEN DO;
    GO TO NEXTFAM;
    END;
  
 ELSE DO;
    *READ HOUSEHOLD RECORD;
 
    INPUT NUMFAM 23-24;
  
    DO IFAM=1 TO NUMFAM;
      INPUT TYPE 7-8 @;
      NEXTFAM:;
      IF TYPE = 0 THEN DO;
           GO TO NEXTHH;
           END;
      ELSE IF TYPE GT 40 AND TYPE LT 80 THEN DO; 
           GO TO NEXTPER; 
           END; 
    *READ FAMILY RECORD;
 
      ELSE INPUT FAMSEQ 2-8 FNUMPER 11-12;
/*  Creating relevant variables */
    FAM18T64=0;
    FAM65OVR=0;
    CHLD=0;
    CHLD18=0;
    CHLD15=0;
    CHLD12=0;
    CHLD3=0;
    CHLD1=0;
    CHLDYGST=99;
    CHLDOLST=0;
    FAM5T17=0;
    FAMINLF=0;
    FAMEARNR=0;

      DO IP = 1 TO FNUMPER;   /* LOOP OVER PERSONS IN FAMILY */ 
 
         NEXTPER:;   /*KLUGE: IN CASE OF BAD REC STRUCTURE */ 
 
         INPUT TYPE 7-8 @;

         IF TYPE =0 THEN DO; 
           if chldygst eq 99 then chldygst=0;
           DROP TYPE IP IFAM INCWGSAL INCEARN AGE EXPLF EXPRRP FAMREL FAMTYPE
           LFSR MARSTAT NUMFAM PFREL RELHEAD;
           output;
           GO TO NEXTHH;
           END; 

         ELSE IF TYPE GT 0 AND TYPE LT 40 THEN DO; 
           IFAM=IFAM+1; 
           if chldygst eq 99 then chldygst=0;
           DROP TYPE IP IFAM INCWGSAL INCEARN AGE EXPLF EXPRRP FAMREL FAMTYPE
           LFSR MARSTAT NUMFAM PFREL RELHEAD;
           OUTPUT;
           GO TO NEXTFAM;
           END; 

          ELSE DO; 
           INPUT EXPRRP 13-14 AGE 15-16 MARSTAT 17 FAMTYPE 31 FAMREL 32
           PFREL 33 RELHEAD 34 LFSR 145 EXPLF 150 INCWGSAL 243-248
           INCEARN 448-455;
         IF AGE GE 15 AND INCWGSAL GT 0 THEN FAMEARNR=FAMEARNR+1;
            ELSE IF AGE GE 15 AND INCEARN NE 0 THEN FAMEARNR=FAMEARNR+1;
         IF AGE GE 15 AND LFSR LE 4 THEN FAMINLF=FAMINLF+1;
         IF AGE GE 65 THEN FAM65OVR=FAM65OVR+1;
         IF AGE GE 18 AND AGE LE 64 THEN FAM18T64=FAM18T64+1;
         IF PFREL EQ 3 THEN CHLD=CHLD+1;
         IF PFREL EQ 3 AND AGE LT 18 THEN CHLD18=CHLD18+1;
         IF PFREL EQ 3 AND AGE LT 15 THEN CHLD15=CHLD15+1;
         IF PFREL EQ 3 AND AGE LT 12 THEN CHLD12=CHLD12+1;
         IF PFREL EQ 3 AND AGE LT 3 THEN CHLD3=CHLD3+1;
         IF PFREL EQ 3 AND AGE LT 1 THEN CHLD1=CHLD1+1;
         IF AGE GE 5 AND AGE LE 17 THEN FAM5T17=FAM5T17+1;
         IF PFREL EQ 3 AND AGE GT CHLDOLST THEN CHLDOLST=AGE;
         IF PFREL EQ 3 AND AGE LT CHLDYGST THEN CHLDYGST=AGE;
         END; 
      IF LASTREC EQ 1 THEN DO;
         if chldygst eq 99 then chldygst=0;
         DROP TYPE IP IFAM INCWGSAL INCEARN AGE EXPLF EXPRRP FAMREL FAMTYPE
         LFSR MARSTAT NUMFAM PFREL RELHEAD;
      OUTPUT;
      END;
 
      END;  /* END OF PERSON LOOP*/ 
      IF CHLDYGST EQ 99 THEN CHLDYGST=0;
      DROP TYPE IP IFAM INCWGSAL INCEARN AGE EXPLF EXPRRP FAMREL FAMTYPE
           LFSR MARSTAT NUMFAM PFREL RELHEAD;
      OUTPUT; 
    END;  /* END OF FAMILY LOOP*/ 
END;  /* END OF HOUSEHOLD LOOP */ 

PROC CONTENTS DATA = SCR.CPS90fmb; 
PROC MEANS DATA = SCR.CPS90fmb; 
/* 
